# SoArray Class Reference
[Nodes]

`#include <Inventor/nodes/SoArray.h>`

Inheritance diagram for SoArray:

List of all members.

## Detailed Description

The SoArray class is a group node for setting up regular arrays of subgraphs.

SoArray presents a convenient way of duplicating a node (typically a shape node) or a complete subgraph in 1 to 3 dimensions.

The child node or subgraph can only be translated by regular offsets for all dimensions.

For more flexible functionality for duplication of geometry, see the SoMultipleCopy group node, which can do general transformations (including rotation and scaling) for it's child.

See also:
  SoMultipleCopy

## Public Types

enum | Origin { FIRST, CENTER, LAST }

## Public Member Functions

| SoArray (void)
virtual SbBool | affectsState (void) const
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | search (SoSearchAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | audioRender (SoAudioRenderAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFEnum | origin
SoSFShort | numElements1
SoSFShort | numElements2
SoSFShort | numElements3
SoSFVec3f | separation1
SoSFVec3f | separation2
SoSFVec3f | separation3

## Protected Member Functions

virtual | ~SoArray ()

## Member Enumeration Documentation

enum SoArray::Origin

| The possible settings for the SoArray::origin field.

## Constructor & Destructor Documentation

SoArray::SoArray | ( | void |  | ) |

| Constructor.

SoArray::~SoArray | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoArray::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoGroup.

SbBool SoArray::affectsState | ( | void |  | ) | const`[virtual]`

Returns `TRUE` if the node could have any effect on the state during traversal.

If it returns `FALSE`, no data in the traversal-state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return `FALSE`, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return `FALSE`, as just pushing out geometry data to the rendering engine won't affect the actual rendering state.

The default method returns `TRUE`, on a "better safe than sorry" philosophy.

Reimplemented from SoNode.

void SoArray::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoGroup.

void SoArray::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoGroup.

void SoArray::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoGroup.

void SoArray::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoGroup.

void SoArray::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoGroup.

void SoArray::handleEvent | ( | SoHandleEventAction * | action | ) | `[virtual]`

| Action method for SoHandleEventAction. Inspects the event data from action, and processes it if it is something which this node should react to. Nodes influencing relevant state variables for how event handling is done also overrides this method. Reimplemented from SoGroup.

void SoArray::getMatrix | ( | SoGetMatrixAction * | action | ) | `[virtual]`

| Action method for SoGetMatrixAction. Updates action by accumulating with the transformation matrix of this node (if any). Reimplemented from SoGroup.

void SoArray::search | ( | SoSearchAction * | action | ) | `[virtual]`

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also:
  SoSearchAction

Reimplemented from SoGroup.

void SoArray::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoGroup.

void SoArray::audioRender | ( | SoAudioRenderAction * | action | ) | `[virtual]`

| Action method for SoAudioRenderAction. Does common processing for SoAudioRenderAction action instances. Reimplemented from SoGroup.

## Member Data Documentation

SoSFEnum SoArray::origin

| Where the origin of the array should be set, ie how the array elements will be distributed from the local origo. Default value is SoArray::FIRST.

SoSFShort SoArray::numElements1

| Number of duplicates for each X axis row. Default 1.

SoSFShort SoArray::numElements2

| Number of duplicates for each Y axis row. Default 1.

SoSFShort SoArray::numElements3

| Number of duplicates for each Z axis row. Default 1.

SoSFVec3f SoArray::separation1

| Distance in current units between the center point of each element along the X axis. Default [1.0, 0.0, 0.0].

SoSFVec3f SoArray::separation2

| Distance in current units between the center point of each element along the Y axis. Default [0.0, 1.0, 0.0].

SoSFVec3f SoArray::separation3

| Distance in current units between the center point of each element along the Z axis. Default [0.0, 0.0, 1.0].

The documentation for this class was generated from the following files:

- SoArray.h
- SoArray.cpp